1 REM 'CURVEIBM.BAS' 12/25/85 BY T. S. COX  FOR DOUBLE PRECISION USE /D ENTERING BASIC
2 REM 'REVISED 12/25/85 CHGD 20055,20067,20068,14570,35015,15102,35016,20041,3590,3584,4507
3 KEY OFF: REM Revised Again 12/13/86 to pretty-up display
4 REM IF USED WITH CP/M OBASIC THIS LINE SHOULD READ 'CLEAR 4000'
5 DEFDBL A,B,C,S,R,X,Y
6 DIM EQ$(25):GOSUB 55000
7 REM revised 11/30/85 to allow null data lines input from LOTUS to be dropped
8 REM revised 12/06/85 for COMPILED version to stop crashing for 0 inputs 
9 CLS:COLOR  7,1,0
10 PRINT"ͻ";
11 PRINT" CURVEFIT   Version 2.10 December 31, 1986      by  Thomas S. Cox  CURVEFIT ";
12 PRINT"͹";
13 PRINT" PURPOSE     This program performs a least squares curve fit on X, Y data.    ";
14 PRINT"             Curves for 25 equations are fitted.  Equation coefficients,      ";
15 PRINT"             Correlation Coefficient, and Best Fit are computed.  For any     ";
16 PRINT"             of the 25 equations, predictions for Y can be calculated.        ";
17 PRINT"                                                                              ";
18 PRINT" REFERENCE   CURVE FITTING FOR PROGRAMMABLE CALCULATORS by William M. Kolb    ";
19 PRINT"             Published by: IMTEC  P. O. Box 1402  Bowie MD  20716             ";
20 PRINT"                                                                              ";
21 PRINT" DISCLAIMER  Although effort has been taken to insure that accurate           ";
22 PRINT"             results are obtained when using this program, the user           ";
23 PRINT"             assumes ALL risks. Good practice dictates that sample data       ";
24 PRINT"             will be used before using REAL data.                             ";
25 PRINT"                                                                              ";
26 PRINT" COPIES      This program is placed in the PUBLIC DOMAIN and may be           ";
27 PRINT"             freely copied.  However, the author retains all commercial       ";
28 PRINT"             rights.  For a copy of latest version send a DSDD (360k) disk    ";
29 PRINT"             and postage or, alternatively, $5.00 to the author at:           ";
30 PRINT"             102 Evergreen St.  Easley, SC  29640.  Comments are welcomed.    ";
31 PRINT"ͼ";
32 PRINT" ":PRINT TAB(2);:INPUT"PRESS <ENTER> TO START PROGRAM EXECUTION";A$
33 CLS:COLOR 7,1,0:XQ=0
55 DIM X1$(255),Y1$(255),X$(255),Y$(255),X(255),Y(255),R(65),RR(25)
56 DIM RC(25),A(25),B(25),C(25):FOR I=1 TO 255:X$(I)="END":Y$(I)="END":NEXT I
110 IF XQ >0 THEN 1000 ELSE 115
115 CLS:COLOR 7,1,0:XQ=1
120 CLS:COLOR 7,1,0:PRINT "ͻ";
130 PRINT " CURVEFIT    Version 2.10 December 31, 1986     by Thomas S. Cox   CURVEFIT ";
131 PRINT "͹";
132 PRINT "                           M A S T E R     M E N U                            ";
134 PRINT "͹";
135 PRINT "  SELECT    CHOICES           BRIEF DESCRIPTION OF CHOICES                  ";
140 PRINT "͹";
150 PRINT "    [ ]     ENTER     New Data (X and Y values) |LIMIT VALUES TO +/- 10,000 ";
160 PRINT "    [ ]     LOAD      A Previously Stored Data File                         ";
170 PRINT "    [ ]     ADD       Data to Values of X and Y Currently in Memory         ";
180 PRINT "    [ ]     DELETE    or CHANGE Values of X and Y Currently in Memory       ";
190 PRINT "    [ ]     LIST      X and Y Values Currently in Memory                    ";
200 PRINT "    [ ]     CALCULATE Equation Coefficients (A, B, C, and R^2)              ";
210 PRINT "    [ ]     PREDICT   Value of Y, given Value of X                          ";
220 PRINT "    [ ]     SHOW      LIST of EQUATIONS Fitted Using this Program           ";
230 PRINT "    [ ]     REVIEW    Equation Coefficients (A, B, C, R^2)                  ";
240 PRINT "    [ ]     DISPLAY   List of SUMS and SUMS of SQUARES                      ";
250 PRINT "    [ ]     STORE     X and Y Data Points to a DISK FILE                    ";
260 PRINT "    [ ]     EXIT      Leave Program and EXIT to DOS                         ";
270 PRINT "͹";
274 PRINT "    USE <UP> OR <DOWN> KEYS TO MAKE SELECTION, PRESS <ENTER>.  <ESC> to EXIT  ";
280 PRINT "ͼ";
284 LP=0
285 D1=8:GOTO 63500        
1000 CLS: COLOR 7,1,0:PRINT "DATA ENTRY ROUTINE": PRINT " "
1001 INPUT"This routine will overwrite any existing data.  OK to proceed (Y) or (N)";A1$
1002 IF LEFT$(A1$,1)="Y" OR LEFT$(A1$,1)="y" THEN 1006
1003 IF LEFT$(A1$,1)="N" OR LEFT$(A1$,1)="n" THEN 120
1004 GOTO 120
1006 FOR I=1 TO 255:X$(I)="END":Y$(I)="END":NEXT I:PRINT"ALL VALUES HAVE BEEN SET TO ZERO"
1008 INPUT "Do you want to have INPUT data listed on printer (Y or N)";Q1$
1009 GOSUB 50000:CLS:COLOR 7,1,0:M=1
1010 PRINT "Enter (S)top for X or Y to terminate data entry."
1011 CLS:COLOR 7,1,0:M=1:MR=1:MC=1
1012 PRINT "ͻ"
1013 PRINT " CURVEFIT    Version 2.10 December 31, 1986     by Thomas S. Cox  CURVEFIT "
1014 PRINT "͹"
1015 PRINT " DATA ENTRY SCREEN|  Enter (S) for X or Y to terminate Data Entry            "
1016 PRINT "͹"
1017 PRINT " PT # X VALUE  Y VALUE  PT # X VALUE  Y VALUE  PT # X VALUE  Y VALUE "
1018 PRINT "͹"
1019 PRINT "                                                                     "
1020 PRINT "                                                                     "
1021 PRINT "                                                                     "
1022 PRINT "                                                                     "
1023 PRINT "                                                                     "
1024 PRINT "                                                                     "
1025 PRINT "                                                                     "
1026 PRINT "                                                                     "
1027 PRINT "                                                                     "
1028 PRINT "                                                                     "
1029 PRINT "                                                                     "
1030 PRINT "                                                                     "
1031 PRINT "                                                                     "
1032 PRINT "                                                                     "
1033 PRINT "͹"
1034 PRINT " ENTER DATA PT #       X VALUE             Y VALUE                      "
1035 PRINT "ͼ";
1036 FOR J=1 TO 255
1040 LOCATE 23,21:PRINT "     ";:LOCATE 23,21:PRINT USING "####";M;
1042 LOCATE 23,36:PRINT"  ";:LOCATE 23,36,1,0,31:INPUT;X$(M):LOCATE 23,36:PRINT"          ";:LOCATE 23,36:PRINT "  "+X$(M);
1044 LOCATE 23,58:PRINT"  ";:LOCATE 23,58,1,0,31:INPUT;Y$(M):LOCATE 23,58:PRINT"          ";:LOCATE 23,58:PRINT "  "+Y$(M);
1046 LOCATE 7+MR,MC+2:PRINT USING "####";M;
1048 LOCATE 7+MR,MC+7:XX1=VAL(X$(M)):PRINT USING "######.##";XX1;:LOCATE 7+MR,MC+17:YY1=VAL(Y$(M)):PRINT USING "######.##";YY1;
1049 MR=MR+1
1052 IF M MOD 14=0 THEN MR=1:MC=MC+26
1053 IF M MOD 42=0 THEN MR=1:MC=1
1054 IF LEFT$(X$(J),1)="S" OR LEFT$(X$(J),1)="s" GOTO 1500
1075 IF LP=1 THEN LPRINT"X( ";J;" )= ";X$(J);TAB(40);"Y( ";J;" )= ";Y$(J)
1077 M=M+1
1080 NEXT J
1090 GOTO 120
1500 X$(J)="END":Y$(J)="END":LOCATE 25,1:PRINT"(S)top encountered.  More Data (Y or N).";:INPUT;A$
1510 IF A$ = "Y" OR A$ = "y" THEN MR=MR-1:LOCATE 25,1:PRINT"                                                    ";:GOTO 1040
1520 GOTO 4620
2000 CLS:COLOR 7,1,0:PRINT"DATA ADDITION ROUTINE":PRINT" "
2011 CLS:COLOR 7,1,0:M=1:MR=1:MC=1
2012 PRINT "ͻ"
2013 PRINT " CURVEFIT    Version 2.10 December 31, 1986     by Thomas S. Cox  CURVEFIT "
2014 PRINT "͹"
2015 PRINT " DATA ADDITION|      Enter (S) for X or Y to terminate Data Entry            "
2016 PRINT "͹"
2017 PRINT " PT # X VALUE  Y VALUE  PT # X VALUE  Y VALUE  PT # X VALUE  Y VALUE "
2018 PRINT "͹"
2019 PRINT "                                                                     "
2020 PRINT "                                                                     "
2021 PRINT "                                                                     "
2022 PRINT "                                                                     "
2023 PRINT "                                                                     "
2024 PRINT "                                                                     "
2025 PRINT "                                                                     "
2026 PRINT "                                                                     "
2027 PRINT "                                                                     "
2028 PRINT "                                                                     "
2029 PRINT "                                                                     "
2030 PRINT "                                                                     "
2031 PRINT "                                                                     "
2032 PRINT "                                                                     "
2033 PRINT "͹"
2034 PRINT " ENTER DATA PT #       X VALUE             Y VALUE                      "
2035 PRINT "ͼ";
2036 FOR J=1 TO 255
2037 IF X$(J)<>"END" OR Y$(J)<>"END" THEN 2046
2040 LOCATE 23,21:PRINT "     ";:LOCATE 23,21:PRINT USING "####";M;
2042 LOCATE 23,36:PRINT"  ";:LOCATE 23,36,1,0,31:INPUT;X$(M):LOCATE 23,36:PRINT"          ";:LOCATE 23,36:PRINT "  "+X$(M);
2044 LOCATE 23,58:PRINT"  ";:LOCATE 23,58,1,0,31:INPUT;Y$(M):LOCATE 23,58:PRINT"          ";:LOCATE 23,58:PRINT "  "+Y$(M);
2046 LOCATE 7+MR,MC+2:PRINT USING "####";M;
2048 LOCATE 7+MR,MC+7:XX1=VAL(X$(M)):PRINT USING "######.##";XX1;:LOCATE 7+MR,MC+17:YY1=VAL(Y$(M)):PRINT USING "######.##";YY1;
2049 MR=MR+1
2052 IF M MOD 14=0 THEN MR=1:MC=MC+26
2053 IF M MOD 42=0 THEN MR=1:MC=1
2054 IF LEFT$(X$(J),1)="S" OR LEFT$(X$(J),1)="s" GOTO 2500
2075 IF LP=1 THEN LPRINT"X( ";J;" )= ";X$(J);TAB(40);"Y( ";J;" )= ";Y$(J)
2077 M=M+1
2080 NEXT J
2090 GOTO 120
2500 X$(J)="END":Y$(J)="END":LOCATE 25,1:PRINT"(S)top encountered.  More Data (Y or N).";:INPUT;A$
2510 IF A$ = "Y" OR A$ = "y" THEN MR=MR-1:LOCATE 25,1:PRINT"                                                    ";:GOTO 2040
2520 GOTO 4620
3000 CLS:COLOR 7,1,0:PRINT"DATA CORRECTION":PRINT" "
3011 CLS:COLOR 7,1,0:M=1:MR=1:MC=1
3012 PRINT "ͻ"
3013 PRINT " CURVEFIT    Version 2.10 December 31, 1986     by Thomas S. Cox  CURVEFIT "
3014 PRINT "͹"
3015 PRINT " DATA CORRECTION| Enter 'D' to DELETE, 'S' to STOP                           "
3016 PRINT "͹"
3017 PRINT " PT # X VALUE  Y VALUE  PT # X VALUE  Y VALUE  PT # X VALUE  Y VALUE "
3018 PRINT "͹"
3019 PRINT "                                                                     "
3020 PRINT "                                                                     "
3021 PRINT "                                                                     "
3022 PRINT "                                                                     "
3023 PRINT "                                                                     "
3024 PRINT "                                                                     "
3025 PRINT "                                                                     "
3026 PRINT "                                                                     "
3027 PRINT "                                                                     "
3028 PRINT "                                                                     "
3029 PRINT "                                                                     "
3030 PRINT "                                                                     "
3031 PRINT "                                                                     "
3032 PRINT "                                                                     "
3033 PRINT "͹"
3034 PRINT " ENTER DATA PT #       X VALUE             Y VALUE                      "
3035 PRINT "ͼ";
3036 FOR J=1 TO 255
3037 IF X$(J)<>"END" OR Y$(J)<>"END" THEN 3046
3040 LOCATE 23,20:PRINT "     ";:LOCATE 23,20:INPUT;M:LOCATE 23,20:PRINT USING "####";M;
3042 LOCATE 23,36:PRINT"  ";:LOCATE 23,36,1,0,31:INPUT;X$(M):IF LEFT$(X$(M),1)="d" OR LEFT$(X$(M),1)="D" THEN X$(M)="DEL"
3043 LOCATE 23,36:PRINT"          ";:LOCATE 23,36:PRINT"  "+X$(M);
3044 LOCATE 23,58:PRINT"  ";:LOCATE 23,58,1,0,31:INPUT;Y$(M):IF LEFT$(Y$(M),1)="d" OR LEFT$(Y$(M),1)="D" THEN Y$(M)="DEL"
3045 LOCATE 23,58:PRINT"          ";:LOCATE 23,58:PRINT"  "+Y$(M);
3046 LOCATE 7+MR,MC+2:PRINT USING "####";M;
3048 LOCATE 7+MR,MC+7:XX1=VAL(X$(M)):PRINT LEFT$(X$(M),8);:LOCATE 7+MR,MC+17:YY1=VAL(Y$(M)):PRINT LEFT$(Y$(M),8);
3049 MR=MR+1
3052 IF M MOD 14=0 THEN MR=1:MC=MC+26
3053 IF M MOD 42=0 THEN MR=1:MC=1
3054 IF LEFT$(X$(M),1)="S" OR LEFT$(X$(M),1)="s" GOTO 3100
3075 IF LP=1 THEN LPRINT"X( ";J;" )= ";X$(J);TAB(40);"Y( ";J;" )= ";Y$(J)
3077 M=M+1
3080 NEXT J
3090 GOTO 120
3100 X$(M)="END":Y$(M)="END":LOCATE 25,1:PRINT"(S)top encountered.  More Data (Y or N).";:INPUT;A$
3110 IF A$ = "Y" OR A$ = "y" THEN MR=MR-1:LOCATE 25,1:PRINT"                                                    ";:GOTO 3040
3120 GOTO 3430
3430 CLS:PRINT "Rearranging Data for Deletions"
3470 K1=1
3480 FOR I= 1 TO 255
3490 X1$(I)=X$(I): Y1$(I)=Y$(I): NEXT I
3540 FOR I= 1 TO 255
3545 IF X1$(I)="DEL" THEN 3580
3550 IF X1$(I)<>"DEL"  THEN GOSUB 3587
3570 IF X1$(I)="END" THEN X$(K1)="END":Y$(K1)="END": GOTO 3582
3580 NEXT I
3582 FOR I= 1 TO 255: IF X$(I)="END" OR LEFT$(X$(I),1)="S" OR LEFT$(X$(I),1)="s" GOTO 3584
3583 NEXT I
3584 PRINT "There are now "; I-1;" VALID data points. ":FOR I=1 TO 500:NEXT I:GOTO 3590
3587 X$(K1)=X1$(I): Y$(K1)=Y1$(I): K1=K1+1: RETURN
3590 Q7=0:IF QA=1 THEN QA=0:GOTO 20045
3591 IF DE=1 THEN DE=0:GOTO 7090
3600 INPUT "LIST NEW DATA SET (Y/N) ";A2$
3610 IF A2$="Y" OR A2$= "y" GOTO 9005 ELSE 120
4000 CLS:COLOR 7,1,0: PRINT "CALCULATING SUMS AND SUMS OF SQUARES"
4010 PRINT "PLEASE HAVE PATIENCE: THIS WILL TAKE SOME TIME!"
4020 GOTO 20000
4040 CLS:COLOR 7,1,0:IF X$(1)="END" OR Y$(1)="END" THEN PRINT "NO DATA ENTERED, CAN'T SHOW COEFFICIENTS!": PRINT CHR$(7): FOR I=1 TO 1000: NEXT I: GOTO 120
4220 MX=0
4230 FOR I=1 TO 25
4240 IF RC(I)>MX THEN 4250
4245 GOTO 4260
4250 MX=RC(I):MQ=I
4260 NEXT I
4265 IF R2=1 THEN R2=0 :RETURN
4500 PRINT CHR$(7):A1$="###":A2$="#.####^^^^":A3$="##.####":A0$="###.####"
4501 INPUT "Output coefficients to printer (Y or N)";Q1$
4502 CLS:COLOR 7,1,0:GOSUB 50000
4503 A4$="EQ#    COEF A      COEF B      COEF C       R^2    R^2 C   EQUATION"
4505 INPUT"Print A, B, and R^2 to SCREEN (ALL DIGITS) First? {Y}es or {N}o ";A$:IF LEFT$(A$,1)="Y" OR LEFT$(A$,1)="y" THEN 35000
4507 CLS:COLOR 7,1,0:INPUT"View Coefficients (A, B, C, R^2, Corr R^2, Eqn) on Screen (Y)es or (N)o ";A$:IF LEFT$(A$,1)="N" OR LEFT$(A$,1)="n" THEN 4572
4510 CLS:COLOR 7,1,0:PRINT A4$
4515 LC=0
4520 FOR I= 1 TO 22
4521 IF A(I)=0 AND B(I)=0 THEN 4532
4530 PRINT USING A1$;I;:PRINT"  ";:PRINT USING A2$;A(I);:PRINT"  ";:PRINT USING A2$;B(I);:PRINT"  ";:PRINT USING A2$;C(I);:PRINT"  ";:PRINT USING A3$;RR(I);:PRINT USING A0$;RC(I);:PRINT" ";:PRINT EQ$(I):LC=LC+1
4532 NEXT I
4535 IF LP=1 THEN 4560
4536 IF LC<=19 THEN 4560
4540 INPUT "Press <Enter> for the remaining coefficients. ";A$
4550 PRINT A4$
4560 FOR I= 23 TO 25
4561 IF A(I)=0 AND B(I)=0 THEN 4571
4570 PRINT USING A1$;I;:PRINT"  ";:PRINT USING A2$;A(I);:PRINT"  ";:PRINT USING A2$;B(I);:PRINT"  ";:PRINT USING A2$;C(I);:PRINT"  ";:PRINT USING A3$;RR(I);:PRINT USING A0$;RC(I);:PRINT" ";:PRINT EQ$(I)
4571 NEXT I
4572  IF LP<>1 THEN 4580
4573 IF LP=1 THEN LPRINT A4$
4574 FOR I=1 TO 25
4575 IF A(I)=0 AND B(I)=0 THEN 4578
4576 IF LP=1 THEN LPRINT USING A1$;I;:LPRINT"  ";:LPRINT USING A2$;A(I);:LPRINT"  ";:LPRINT USING A2$;B(I);:LPRINT"  ";:LPRINT USING A2$;C(I);:LPRINT"  ";:LPRINT USING A3$;RR(I);:LPRINT USING A0$;RC(I);:LPRINT" ";:LPRINT EQ$(I)
4578 NEXT I
4580 R2=1: GOSUB 4220
4600 PRINT "Based on the value of RC(), the best fit was # ";MQ
4605 IF LP=1 THEN LPRINT"BASED ON THE VALUE OF RC( )--BEST FITTING CURVE WAS NUMBER";MQ
4610 INPUT "PRESS <ENTER> to return to MAIN MENU";A$
4620 IF LP=1 THEN LPRINT CHR$(12)
4630 GOTO 120
4990 PRINT CL$: AZ$=""
5000 K=0:L=0:IF AZ$="S" THEN INPUT "All data entered, press <Enter> to continue";A$
5002 CLS:COLOR 7,1,0: PRINT "Predicted value of Y, given X":K=1
5003  INPUT "Quit and return to main menu or Predict (Q or P)";AZ$
5004 PRINT CL$:IF L=1 AND LP=1 THEN LPRINT CHR$(12)
5005 IF LEFT$(AZ$,1)="q" OR LEFT$(AZ$,1)="Q" THEN 120
5006 INPUT "Output results to printer (Y or N) ";Q1$
5007 GOSUB 50000
5010 INPUT "Starting value for X";SX
5020 INPUT "Ending value for X";EX
5030 INPUT "Step value for X";ST
5040 INPUT "Equation number for prediction (1-25)";EQ
5050 IF EQ<1 OR EQ>25 GOTO 120
5051 IF A(EQ)=0 AND B(EQ)=0 THEN PRINT"THE EQUATION  ";EQ$(EQ);" IS NOT DEFINED FOR THIS DATA SET.":PRINT"RETURNING TO MAIN MENU":FOR M=1 TO 2000:NEXT M:GOTO 120
5052 PRINT "PREDICTIONS ARE FOR EQUATION ";TAB(40);EQ$(EQ)
5053 IF LP=1 THEN LPRINT"PREDICTIONS FOR EQUATION ";EQ$(EQ):LPRINT" "
5060 K=0:ON EQ GOTO 5100,5110,5120,5130,5140,5150,5160,5170,5180,5190,5200,5210,5220,5230,5240,5250,5260,5270,5280,5290,5300,5310,5320,5330,5340,5350
5100 FOR Q=SX TO EX STEP ST:Y=A(1)+B(1)*Q:GOSUB 5500:NEXT Q:GOTO 5003
5110 FOR Q=SX TO EX STEP ST:Y=B(2)*Q:GOSUB 5500:NEXT Q:GOTO 5003
5120 FOR Q=SX TO EX STEP ST:Y=1/(A(3)+B(3)*Q):GOSUB 5500:NEXT Q:GOTO 5003
5130 FOR Q=SX TO EX STEP ST:Y=A(4)+B(4)*Q+C(4)/Q:GOSUB 5500:NEXT Q:GOTO 5003
5140 FOR Q=SX TO EX STEP ST:Y=A(5)+B(5)/Q:GOSUB 5500:NEXT Q:GOTO 5003
5150 FOR Q=SX TO EX STEP ST:Y=Q/(A(6)*Q+B(6)):GOSUB 5500:NEXT Q:GOTO 5003
5160 FOR Q=SX TO EX STEP ST:Y=A(7)+B(7)/Q+C(7)/(Q*Q):GOSUB 5500:NEXT Q:GOTO 5003
5170 FOR Q=SX TO EX STEP ST:Y=A(8)+B(8)*Q+C(8)*Q*Q:GOSUB 5500:NEXT Q:GOTO 5003
5180 FOR Q=SX TO EX STEP ST:Y=A(9)*Q+B(9)*Q*Q:GOSUB 5500:NEXT Q:GOTO 5003
5190 FOR Q=SX TO EX STEP ST:Y=A(10)*Q^B(10):GOSUB 5500:NEXT Q:GOTO 5003
5200 FOR Q=SX TO EX STEP ST:Y=A(11)*B(11)^Q:GOSUB 5500:NEXT Q:GOTO 5003
5210 FOR Q=SX TO EX STEP ST:Y=A(12)*B(12)^(1/Q):GOSUB 5500:NEXT Q:GOTO 5003
5220 FOR Q=SX TO EX STEP ST:Y=A(13)*Q^(B(13)*Q):GOSUB 5500:NEXT Q:GOTO 5003
5230 FOR Q=SX TO EX STEP ST:Y=A(14)*Q^(B(14)/Q):GOSUB 5500:NEXT Q:GOTO 5003
5240 FOR Q=SX TO EX STEP ST:Y=A(15)*EXP(B(15)*Q):GOSUB 5500:NEXT Q:GOTO 5003
5250 FOR Q=SX TO EX STEP ST:Y=A(16)*EXP(B(16)/Q):GOSUB 5500:NEXT Q:GOTO 5003
5260 FOR Q=SX TO EX STEP ST:Y=A(17)+B(17)*LOG(Q):GOSUB 5500:NEXT Q:GOTO 5003
5270 FOR Q=SX TO EX STEP ST:Y=1/(A(18)+B(18)*LOG(Q)):GOSUB 5500:NEXT Q:GOTO 5003
5280 FOR Q=SX TO EX STEP ST:Y=A(19)*B(19)^Q*Q^C(19):GOSUB 5500:NEXT Q:GOTO 5003
5290 FOR Q=SX TO EX STEP ST:Y=A(20)*B(20)^(1/Q)*Q^C(20):GOSUB 5500:NEXT Q:GOTO 5003
5300 FOR Q=SX TO EX STEP ST:Y=A(21)*EXP((Q-B(21))/2):GOSUB 5500:NEXT Q:GOTO 5003
5310 FOR Q=SX TO EX STEP ST:Y=A(22)*EXP((LOG(Q)-B(22))^2/C(22)):GOSUB 5500:NEXT Q:GOTO 5003
5320 FOR Q=SX TO EX STEP ST:Y=A(23)*Q^B(23)*(1-Q)^C(23):GOSUB 5500:NEXT Q:GOTO 5003
5330 FOR Q=SX TO EX STEP ST:Y=A(24)*(Q/B(24))^C*EXP(Q/B(24)):GOSUB 5500:NEXT Q:GOTO 5003
5340 FOR Q=SX TO EX STEP ST:Y=1/(A(25)*(Q+B(25))^2+C(25)):GOSUB 5500:NEXT Q:GOTO 5003
5350 REM * END OF Y PREDICTIONS *
5500 REM *
5502 L=1
5505 IF LP=1 THEN LPRINT"If X= ";Q,"Then Y= ";Y
5510 PRINT "IF X= ";Q,"THEN Y= ";Y:K=K+1
5511 IF LP=1 THEN 5515
5512 IF INT(K/22)=K/22 THEN PRINT"PRESS <ENTER> TO CONTINUE":INPUT AQ
5515 IF LP=1 AND (INT(K/60)=(K/60)) THEN LPRINT CHR$(12)
5520 RETURN
6000 REM * STORE DATA ON DISK (RAW DATA ONLY) *
6030 CLS:PRINT "This routine will store RAW DATA on Disk"
6035 ON ERROR GOTO 63000
6040 INPUT "Please enter File Name for Data Storage ";A4$
6050 OPEN "O",1,A4$
6060 FOR I=1 TO 255
6065 IF X$(I)="END" AND Y$(I)="END" THEN PRINT #1, X$(I):PRINT #1,Y$(I):CLOSE 1:GOTO 6080
6070 PRINT #1,X$(I):PRINT #1,Y$(I):NEXT I:CLOSE 1
6080 PRINT "Data have been stored to disk with File Name ";A4$
6090 INPUT "Press <Enter> to return to MAIN MENU";Z0
6100 GOTO 120
6772 0 PRINT "                                                                      "
7000 REM * LOAD DATA FROM DISK *
7030 CLS:PRINT"This routine will load DATA from Disk"
7035 ON ERROR GOTO 61000
7040 INPUT "PLEASE Enter File Name for Data ";A4$
7045 NX=0:NY=0
7050 OPEN "I",1,A4$
7060 FOR I=1 TO 255
7065 IF EOF(1) THEN PRINT"ALL DATA LOADED":K=I:FOR J=K TO 255:X$(J)="END":Y$(J)="END":NEXT J:GOTO 7075
7070 INPUT #1,X$(I)
7071 IF INSTR(2,X$(I)," ")<>0 THEN 7200
7073 INPUT #1,Y$(I):NEXT I
7075 CLOSE 1
7080 PRINT "Data loaded from file ";A4$
7082 FOR I=1 TO 255:IF X$(I)="" THEN X$(I)="DEL":Y$(I)="DEL"
7083 IF X$(I)="END" THEN IF X$(1)<>"DEL" THEN 7090 ELSE DE=1:GOTO 3430
7084 NEXT I:DE=1:GOTO 3430
7090 INPUT "Press ENTER to Continue";A9:GOTO 3430
7100 GOTO 120
7200 CLOSE 1:OPEN "I",1,A4$
7210 FOR I=1 TO 255
7220 IF EOF(1) THEN PRINT"ALL DATA LOADED":K=I:FOR J=K TO 255:X$(J)="END":Y$(J)="END":NEXT J:GOTO 7275
7230 INPUT #1,DUMM$
7240 PM=INSTR(2,DUMM$," "):X$(I)=LEFT$(DUMM$,PM):Y$(I)=RIGHT$(DUMM$,LEN(DUMM$)-PM):NEXT I
7275 GOTO 7075
8000 CLS:COLOR 7,1,0:PRINT"PROGRAM EXECUTION HAS BEEN TERMINATED"
8010 INPUT "Before exiting do you wish to store data on disk (Y or N)";A$
8020 IF LEFT$(A$,1)="N" OR LEFT$(A$,1)="n"  THEN END
8030 GOTO 6030
9000 REM * LIST RAW DATA *
9005 CLS:COLOR 7,1,0:PRINT "LIST OF DATA ENTERED"
9006 INPUT "Do you want to list data on printer (Y or N)";Q1$
9007 GOSUB 50000:GOTO 63700
9008 IF LP=1 THEN LPRINT"LISTING OF DATA":LPRINT" "
9009 IF LP=0 THEN 9100
9010 FOR I=1 TO 255
9020 IF X$(I)="END" OR Y$(I)="END" THEN LPRINT CHR$(12):GOTO 9100
9065 IF LP=1 THEN LPRINT"X( ";I;" )= ";X$(I);TAB(32);"Y( ";I;" )= ";Y$(I)
9066 IF LP=1 AND (INT(I/60)=(I/60)) THEN LPRINT CHR$(12) 
9074 NEXT I:IF LP=1 THEN LPRINT CHR$(12)
9100 IF Q7=1 THEN  Q7=0:RETURN
9110 GOTO 120
10000 CLS:COLOR 7,1,0
10010 PRINT "ͻ"
10020 PRINT "                      EQUATIONS FITTED USING THIS PROGRAM                  "
10030 PRINT "͹"
10040 PRINT "  1. Y=A+B*X       STR. LINE           2. Y=B*X           LINE THRU ORG.  "
10050 PRINT "  3. Y=1/(A+B*X)   REC. STR LINE       4. Y=A+B*X+C/X     LIN AND RECIP.  "
10060 PRINT "  5. Y=A+B/X       HYPERBOLA           6. Y=X/(A*X+B)     RECIP HYPERBOLA "
10070 PRINT "  7. Y=A+B/X+C/X*X 2ND ORD HYP         8. Y=A+B*X+C*X*X   PARABOLA        "
10080 PRINT "  9. Y=A*X+B*X*X   PAR AT ORIGIN      10. Y=A*X^B         POWER           "
10090 PRINT " 11. Y=A*B^X       MOD. POWER         12. Y=B^(1/X)       ROOT            "
10100 PRINT " 13. Y=A*X^(B*X)   SUPER GEOMET.      14. Y=A*X^(B/X)     MOD GEOMETRIC   "
10110 PRINT " 15. Y=A*e^(B*X)   EXPONENTIAL        16. Y=A*e^(B/X)     MOD EXPONENTIAL "
10120 PRINT " 17. Y=A+B*ln(X)   LOGARITHMIC        18. Y=1/(A+B*ln(X))   RECIP LOG     "
10130 PRINT " 19. Y=A*B^X*X^C   HOERL FUNCTION     20. Y=A*B^(1/X)*X^C   MOD HOERL     "
10140 PRINT " 21. Y=A*e^((X-B)/2)   NORMAL         22. Y=A*e^((ln(X)-B)^2/C) LOG NORMAL"
10150 PRINT " 23. Y=A*X^B*(1-X)^C   BETA           24. Y=A*(X/B)^C*e^(X/B)   GAMMA     "
10160 PRINT " 25. Y=1/(A*(X+B)^2+C) CAUCHY                                             "
10170 PRINT "͹"
10180 PRINT "      NOTES:  A.  Values of X and Y may be positive, negative, or zero     "
10190 PRINT "              B.  Only 255 values of X and Y can be used.                  "
10200 PRINT "͹"
10210 PRINT "      Press <RETURN> to continue program execution                         "
10220 PRINT "ͼ"
10230 A$=INKEY$:IF A$<>CHR$(13) THEN 10230 ELSE 10460
10460 IF R1=1 THEN RETURN ELSE 120
12000 FOR I=1 TO 25:A(I)=0:B(I)=0:C(I)=0:RR(I)=0:RC(I)=0:NEXT I
12005 REM * EQUATION 1 STRAIGHT LINE
12007 ON ERROR GOTO 0
12010 A(1)=(R(17)*R(18)-R(16)*R(20))/(R(17)*R(21)-(R(16)*R(16)))
12020 B(1)=(R(20)*R(21)-R(16)*R(18))/(R(17)*R(21)-(R(16)*R(16)))
12030 RR(1)=(A(1)*R(18)+B(1)*R(20)-(R(18)*R(18))/R(21))/(R(19)-(R(18)*R(18))/R(21))
12040 RC(1)=1-(((1-RR(1))*(R(21)-1))/(R(21)-2))
12050 C(1)=0
12060 REM * EQUATION 2 STRAIGHT LINE THROUGH ORIGIN *
12070 A(2)=0: B(2)=R(20)/R(17): RR(2)=0: RC(2)=0: C(2)=0
12140 REM * EQUATION 3 RECIPROCAL OF STRAIGHT LINE
12150 A(3)=(R(17)*R(24)-R(16)*R(34))/(R(17)*R(21)-(R(16)*R(16)))
12160 B(3)=(R(21)*R(34)-R(16)*R(24))/(R(17)*R(21)-(R(16)*R(16)))
12170 RR(3)=(A(3)*R(24)+B(3)*R(34)-((R(24)*R(24))/R(21)))/(R(25)-(R(24)*R(24))/R(21))
12180 RC(3)=1-(((1-RR(3))*(R(21)-1))/(R(21)-2))
12190 C(3)=0
12200 REM * EQUATION 4  COMBINED LINEAR AND RECIPROCAL *
12220 S1=R(17)*R(21)-(R(16)*R(16))
12230 S2=R(21)*R(35)-R(18)*R(22)
12240 S3=(R(21)*R(21))-R(16)*R(22)
12250 S4=R(20)*R(21)-R(16)*R(18)
12260 S5=R(21)*R(23)-(R(22)*R(22))
12270 C(4)=(S1*S2-S3*S4)/(S1*S5-(S3*S3))
12280 B(4)=(S4-S3*C(4))/S1
12290 A(4)=(R(18)-B(4)*R(16)-C(4)*R(22))/R(21)
12300 RR(4)=(A(4)*R(18)+B(4)*R(20)+C(4)*R(35)-(R(18)*R(18))/R(21))/(R(19)-(R(18)*R(18))/R(21))
12310 RC(4)=1-(((1-RR(4))*(R(21)-1))/(R(21)-3))
12320 REM * EQUATION 5  HYPERBOLA *
12330 S1=R(21)*R(23)-(R(22)*R(22))
12340 A(5)=(R(18)*R(23)-R(22)*R(35))/S1
12360 B(5)=(R(21)*R(35)-R(18)*R(22))/S1
12370 RR(5)=(A(5)*R(18)+B(5)*R(35)-(R(18)*R(18))/R(21))/(R(19)-(R(18)*R(18))/R(21))
12380 RC(5)=1-(((1-RR(5))*(R(21)-1))/(R(21)-2))     
12390 C(5)=0
12400 REM * EQUATION 6  RECIPROCAL OF A HYPERBOLA *
12420 S1=R(21)*R(23)-(R(22)*R(22))
12430 A(6)=(R(23)*R(24)-R(22)*R(26))/S1
12440 B(6)=(R(21)*R(26)-R(22)*R(24))/S1  
12450 RR(6)=(A(6)*R(24)+B(6)*R(26)-(R(24)*R(24))/R(21))/(R(25)-(R(24)*R(24))/R(21))
12460 RC(6)=1-(((1-RR(6))*(R(21)-1))/(R(21)-2))
12462 C(6)=0
12470 REM * EQUATION 7  SECOND ORDER HYPERBOLA *
12490 S1=R(21)*R(23)-(R(22)*R(22))
12500 S2=R(21)*R(38)-R(18)*R(23)
12510 S3=R(21)*R(41)-R(22)*R(23)
12520 S4=R(21)*R(35)-R(18)*R(22)
12530 S5=R(21)*R(44)-(R(23)*R(23))
12532 ON ERROR GOTO 0
12535 IF (S1*S5-S3*S3)=0 THEN 12620
12540 C(7)=(S1*S2-S3*S4)/(S1*S5-(S3*S3))
12545 IF C(7)>=9.999999E+37 THEN A(7)=0:B(7)=0:C(7)=0:GOTO 12590
12550 B(7)=(S4-S3*C(7))/S1
12560 A(7)=(R(18)-C(7)*R(23)-B(7)*R(22))/R(21)
12570 RR(7)=(A(7)*R(18)+B(7)*R(35)+C(7)*R(38)-(R(18)*R(18))/R(21))/(R(19)-(R(18)*R(18))/R(21))
12580 RC(7)=1-(((1-RR(7))*(R(21)-1))/(R(21)-3))  
12590 REM * EQUATION 8  PARABOLA *
12620 S1=R(17)*R(21)-(R(16)*R(16))
12630 S2=R(21)*R(36)-R(17)*R(18)
12640 S3=R(21)*R(40)-R(16)*R(17)
12650 S4=R(20)*R(21)-R(16)*R(18)
12660 S5=R(21)*R(43)-(R(17)*R(17))
12670 C(8)=(S1*S2-S3*S4)/(S1*S5-(S3*S3))
12680 B(8)=(S4-S3*C(8))/S1
12690 A(8)=(R(18)-C(8)*R(17)-B(8)*R(16))/R(21)
12700 RR(8)=(A(8)*R(18)+B(8)*R(20)+C(8)*R(36)-(R(18)*R(18))/R(21))/(R(19)-(R(18)*R(18))/R(21))
12710 RC(8)=1-(((1-RR(8))*(R(21)-1))/(R(21)-3))
12720 REM * EQUATION 9  PARABOLA THROUGH ORIGIN *
12750 S1=R(17)*R(43)-(R(40)*R(40))
12760 A(9)=(R(20)*R(43)-R(36)*R(40))/S1
12770 B(9)=(R(17)*R(36)-R(20)*R(40))/S1
12780 C(9)=0: RR(9)=0: RC(9)=0
12810 REM * EQUATION 10  POWER *
12820 IF NX=1 OR NY=1 THEN 13000
12840 S1=R(21)*R(29)-(R(28)*R(28))
12850 S3=(R(29)*R(30)-R(28)*R(32))/S1
12860 A(10)=EXP((R(29)*R(30)-R(28)*R(32))/S1)
12870 B(10)=(R(21)*R(32)-R(28)*R(30))/S1    
12875 RR(10)=(S3*R(30)+B(10)*R(32)-(R(30)*R(30))/R(21))/(R(31)-(R(30)*R(30))/R(21))
12880 IF RR(10)<0 OR RR(10)>1 THEN A(10)=0:B(10)=0:GOTO 13000
12890 RC(10)=1-(((1-RR(10))*(R(21)-1))/(R(21)-2))
12895 C(10)=0
13000 REM * EQUATION 11  MODIFIED POWER *
13010 IF NY=1 THEN 13110
13020 S1=R(17)*R(21)-(R(16)*R(16))
13030 S2=(R(17)*R(30)-R(16)*R(46))/S1
13040 S3=(R(21)*R(46)-R(16)*R(30))/S1
13060 A(11)=EXP(S2)
13070 B(11)=EXP(S3)
13080 RR(11)=(S2*R(30)+S3*R(46)-(R(30)*R(30))/R(21))/(R(31)-(R(30)*R(30))/R(21))
13090 RC(11)=1-(((1-RR(11))*(R(21)-1))/(R(21)-2))
13100 C(11)=0
13110 REM * EQUATION 12  ROOT *
13120 IF NY=1 THEN 13210
13140 S1=R(23)*R(21)-(R(22)*R(22))
13150 S2=(R(23)*R(30)-R(22)*R(47))/S1
13160 S3=(R(21)*R(47)-R(22)*R(30))/S1
13165 IF S2>87 OR S3>87 THEN 13210
13170 A(12)=EXP(S2)
13180 B(12)=EXP(S3)
13190 RR(12)=(S2*R(30)+S3*R(47)-(R(30)*R(30))/R(21))/(R(31)-(R(30)*R(30))/R(21))
13200 RC(12)=1-(((1-RR(12))*(R(21)-1))/(R(21)-2)):C(12)=0
13210 REM * EQUATION 13  SUPER GEOMETRIC *
13220 IF NX=1 OR NY=1 THEN 13400
13240 S1=R(21)*R(49)-(R(48)*R(48))
13250 S2=(R(30)*R(49)-R(48)*R(50))/S1
13260 A(13)=EXP(S2)
13270 B(13)=(R(21)*R(50)-R(30)*R(48))/S1
13280 RR(13)=(S2*R(30)+B(13)*R(50)-(R(30)*R(30))/R(21))/(R(31)-(R(30)*R(30))/R(21))
13290 RC(13)=1-(((1-RR(13))*(R(21)-1))/(R(21)-2))
13295 C(13)=0
13300 REM * EQUATION 14  MODIFIED GEOMETRIC *
13330 S1=R(21)*R(53)-(R(63)*R(63))
13340 S2=(R(30)*R(53)-R(63)*R(58))/S1
13350 A(14)=EXP(S2)
13360 B(14)=(R(21)*R(58)-R(30)*R(63))/S1
13370 RR(14)=(S2*R(30)+B(14)*R(58)-(R(30)*R(30))/R(21))/(R(31)-(R(30)*R(30))/R(21))
13380 RC(14)=1-(((1-RR(14))*(R(21)-1))/(R(21)-2))
13390 C(14)=0
13400 REM * EQUATION 15  EXPONENTIAL *
13420 IF NY=1 THEN 13600
13430 S1=R(17)*R(21)-(R(16)*R(16))
13440 S2=(R(17)*R(30)-R(16)*R(46))/S1
13450 A(15)=EXP(S2)
13460 B(15)=(R(21)*R(46)-R(16)*R(30))/S1
13470 RR(15)=(S2*R(30)+R(46)*B(15)-(R(30)*R(30))/R(21))/(R(31)-(R(30)*R(30))/R(21))
13480 RC(15)=1-(((1-RR(15))*(R(21)-1))/(R(21)-2))  
13490 C(15)=0
13500 REM * EQUATION 16  MODIFIED EXPONENTIAL *
13530 S1=R(23)*R(21)-(R(22)*R(22))
13540 S2=(R(23)*R(30)-R(22)*R(47))/S1
13550 A(16)=EXP(S2)
13560 B(16)=(R(21)*R(47)-R(22)*R(30))/S1
13570 RR(16)=(S2*R(30)+B(16)*R(47)-(R(30)*R(30))/R(21))/(R(31)-(R(30)*R(30))/R(21))
13580 RC(16)=1-(((1-RR(16))*(R(21)-1))/(R(21)-2)):C(16)=0
13600 REM * EQUATION 17  LOGARITHMIC *
13620 IF NX=1 THEN 14000
13630 S1=R(21)*R(29)-(R(28)*R(28))
13640 A(17)=(R(18)*R(29)-R(28)*R(51))/S1
13650 B(17)=(R(21)*R(51)-R(18)*R(28))/S1
13660 RR(17)=(A(17)*R(18)+B(17)*R(51)-(R(18)*R(18))/R(21))/(R(19)-(R(18)*R(18))/R(21))
13670 C(17)=0: RC(17)=1-(((1-RR(17))*(R(21)-1))/(R(21)-2))
13680 REM * EQUATION 18  RECIPROCAL OF LOGARITHMIC *
13710 S1=R(21)*R(29)-(R(28)*R(28))
13720 A(18)=(R(24)*R(29)-R(28)*R(52))/S1
13730 B(18)=(R(21)*R(52)-R(24)*R(28))/S1
13740 RR(18)=(A(18)*R(24)+B(18)*R(52)-(R(24)*R(24))/R(21))/(R(25)-(R(24)*R(24))/R(21))
13750 C(18)=0:RC(18)=1-(((1-RR(18))*(R(21)-1))/(R(21)-2))
14000 REM * EQUATION 19  HOERL FUNCTION *
14020 IF NX=1 OR NY=1 THEN 14300
14030 S1=R(17)*R(21)-(R(16)*R(16))
14040 S2=R(21)*R(32)-R(28)*R(30)
14050 S3=R(21)*R(48)-R(16)*R(28) 
14060 S4=R(21)*R(46)-R(16)*R(30)
14070 S5=R(21)*R(29)-(R(28)*R(28))
14080 C(19)=(S1*S2-S3*S4)/(S1*S5-(S3*S3))
14090 S6=(S4-S3*C(19))/S1
14100 S7=(R(30)-C(19)*R(28)-S6*R(16))/R(21)
14105 IF S7>87 OR S8>87 THEN A(19)=0:B(19)=0:C(19)=0:GOTO 14150
14110 B(19)=EXP(S6)
14120 A(19)=EXP(S7)
14130 RR(19)=(S7*R(30)+S6*R(46)+C(19)*R(32)-(R(30)*R(30))/R(21))/(R(31)-(R(30)*R(30))/R(21))
14140 RC(19)=1-(((1-RR(19))*(R(21)-1))/(R(21)-3))
14150 REM * EQUATION 20  MODIFIED HOERL FUNCTION *
14180 S1=R(21)*R(23)-(R(22)*R(22))
14190 S2=R(21)*R(32)-R(28)*R(30)
14200 S3=R(21)*R(45)-R(22)*R(28)
14210 S4=R(21)*R(47)-R(22)*R(30)
14220 S5=R(21)*R(29)-(R(28)*R(28))
14230 C(20)=(S1*S2-S3*S4)/(S1*S5-(S3*S3))
14240 S6=(S4-S3*C(20))/S1
14250 S7=(R(30)-C(20)*R(28)-S6*R(22))/R(21)
14255 IF S6>87 OR S7>87 THEN A(20)=0:B(20)=0:C(20)=0:GOTO 14300
14260 A(20)=EXP(S7)
14270 B(20)=EXP(S6)
14280 RR(20)=(S7*R(30)+S6*R(47)+C(20)*R(32)-(R(30)*R(30))/R(21))/(R(31)-(R(30)*R(30))/R(21))
14290 RC(20)=1-(((1-RR(20))*(R(21)-1))/(R(21)-3))
14300 REM * EQUATION 21  NORMAL DISTRIBUTION *
14310 IF NY=1 THEN 14460
14330 S1=R(17)*R(21)-(R(16)*R(16))
14340 S2=R(21)*R(54)-R(17)*R(30)
14350 S3=R(21)*R(40)-R(16)*R(17)
14360 S4=R(21)*R(46)-R(16)*R(30)
14370 S5=R(21)*R(43)-(R(17)*R(17))
14380 S6=(S1*S2-S3*S4)/(S1*S5-(S3*S3))
14390 S7=(S4-S3*S6)/S1
14400 S8=(R(30)-S7*R(16)-S6*R(17))/R(21)
14410 A(21)=EXP(S8-((S7*S7)/(4*S6)))
14420 B(21)=-S7/(2*S6)
14430 C(21)=1/S6
14440 RR(21)=(S8*R(30)+S7*R(46)+S6*R(54)-(R(30)*R(30))/R(21))/(R(31)-(R(30)*R(30))/R(21))
14450 RC(21)=1-(((1-RR(21))*(R(21)-1))/(R(21)-3))
14460 REM * EQUATION 22  LOG NORMAL DISTRIBUTION *
14470 IF NX=1 OR NY=1 THEN 14620
14490 S1=R(21)*R(29)-(R(28)*R(28))
14500 S2=R(21)*R(57)-R(29)*R(30)
14510 S3=R(21)*R(55)-R(28)*R(29)
14520 S4=R(21)*R(32)-R(28)*R(30)
14530 S5=R(21)*R(56)-(R(29)*R(29))
14540 S6=(S1*S2-S3*S4)/(S1*S5-(S3*S3))
14550 S7=(S4-S3*S6)/S1
14560 S8=(R(30)-S7*R(28)-S6*R(29))/R(21)
14565 ON ERROR GOTO 0
14570 Z=(S8-(S7*S7)/(4*S6)):IF Z>85 THEN 14620 ELSE A(22)=EXP(Z)
14580 B(22)=-S7/(2*S6)
14590 C(22)=1/S6
14600 RR(22)=(S8*R(30)+S7*R(32)+S6*R(57)-(R(30)*R(30))/R(21))/(R(31)-(R(30)*R(30))/R(21))
14610 RC(22)=1-(((1-RR(22))*(R(21)-1))/(R(21)-3))
14620 REM * EQUATION 23  BETA DISTRIBUTION *
14645 IF Q9=1 THEN GOTO 14790
14650 S1=R(21)*R(29)-(R(28)*R(28))
14660 S2=R(21)*R(62)-R(30)*R(59)
14670 S3=R(21)*R(61)-R(28)*R(59)
14680 S4=R(21)*R(32)-R(28)*R(30)
14690 S5=R(21)*R(60)-(R(59)*R(59))
14700 C(23)=(S1*S2-S3*S4)/(S1*S5-(S3*S3))
14710 B(23)=(S4-S3*C(23))/S1
14720 S6=(R(30)-B(23)*R(28)-C(23)*R(59))/R(21)
14730 A(23)=EXP(S6)
14740 RR(23)=(S6*R(30)+B(23)*R(32)+C(23)*R(62)-(R(30)*R(30))/R(21))/(R(31)-(R(30)*R(30))/R(21))
14750 RC(23)=1-(((1-RR(23))*(R(21)-1))/(R(21)-3))
14760 REM * EQUATION 24  GAMMA DISTRIBUTION *
14765 IF NX=1 OR NY=1 THEN 14960
14790 S1=R(17)*R(21)-(R(16)*R(16))
14800 S2=R(21)*R(32)-R(28)*R(30)
14810 S3=R(21)*R(48)-R(16)*R(28)
14820 S4=R(21)*R(46)-R(16)*R(30)
14830 S5=R(21)*R(29)-(R(28)*R(28))
14840 C(24)=(S1*S2-S3*S4)/(S1*S5-(S3*S3))
14850 S6=(S4-S3*C(24))/S1
14860 S7=(R(30)-S6*R(16)-C(24)*R(28))/R(21)
14870 B(24)=1/S6
14875 IF S6<=0 THEN B(24)=0:C(24)=0:GOTO 14960
14880 A(24)=EXP(S7+C(24)*LOG(1/S6))
14890 RR(24)=(S7*R(30)+S6*R(46)+C(24)*R(32)-(R(30)*R(30))/R(21))/(R(31)-(R(30)*R(30))/R(21))
14895 RC(24)=1-(((1-RR(24))*(R(21)-1))/(R(21)-3))
14920 REM * EQUATION 25  CAUCHY DISTRIBUTION *
14960 S1=R(17)*R(21)-(R(16)*R(16))
14970 S2=R(21)*R(37)-R(17)*R(24)
14980 S3=R(21)*R(40)-R(16)*R(17)
14990 S4=R(21)*R(34)-R(16)*R(24)
15000 S5=R(21)*R(43)-(R(17)*R(17))
15010 A(25)=(S1*S2-S3*S4)/(S1*S5-(S3*S3))
15020 S6=(S4-S3*A(25))/S1
15030 S7=(R(24)-S6*R(16)-A(25)*R(17))/R(21)
15040 B(25)=(S6/(2*A(25)))
15050 C(25)=S7-((S6*S6)/(4*A(25)))
15060 RR(25)=(S7*R(24)+S6*R(34)+A(25)*R(37)-(R(24)*R(24))/R(21))/(R(25)-(R(24)*R(24))/R(21))
15070 RC(25)=1-(((1-RR(25))*(R(21)-1))/(R(21)-3))
15090 PRINT"COEFFICIENTS NOW CALCULATED "
15100 FOR I=1 TO 25
15102 IF RR(I)<0 OR RR(I)>1.0001 THEN A(I)=0:B(I)=0:RC(I)=0:C(I)=0:RR(I)=0
15104 NEXT I
15106 GOTO 4040
20000 REM * CALCULATE SUMS AND SUMS OF SQUARES *
20010 NX=0:NY=0
20040 FOR I=16 TO 65: R(I)=0: NEXT I
20041 Q9=0:QA=1:GOTO 3430
20045 FOR I=1 TO 255
20046 CLS:COLOR 7,1,0:PRINT"PROCESSING DATA POINT # "; I
20047 IF X$(1)="END" OR Y$(1)="END" THEN PRINT "NO DATA HAS BEEN ENTERED":PRINT"RETURNING TO MAIN MENU":FOR I1=1 TO 1000:NEXT I1:GOTO 120
20055 IF X$(I)= "END" OR Y$(I)="END" OR X$(I)="DEL" OR Y$(I)="DEL" GOTO 30000
20060 X(I)=CDBL(VAL(X$(I))):Y(I)=CDBL(VAL(Y$(I)))
20065 IF X(I)<0 THEN NX=1
20066 IF Y(I)<0 THEN NY=1
20067 IF X(I)=0 THEN X(I)=.0001
20068 IF Y(I)=0 THEN Y(I)=.0001
20070 R(16)=R(16)+X(I)
20080 R(17)=R(17)+X(I)*X(I)
20090 R(18)=R(18)+Y(I)
20100 R(19)=R(19)+Y(I)*Y(I)
20110 R(20)=R(20)+X(I)*Y(I)
20120 R(21)=I
20130 R(22)=R(22)+(1/X(I))
20140 R(23)=R(23)+(1/(X(I)*X(I)))
20150 R(24)=R(24)+(1/(Y(I)))
20160 R(25)=R(25)+(1/(Y(I)*Y(I)))
20170 R(26)=R(26)+(1/(Y(I)*X(I)))
20180 R(27)=I      
20190 IF NX<>1 THEN R(28)=R(28)+LOG(X(I))
20200 IF NX<>1 THEN R(29)=R(29)+(LOG(X(I)))*(LOG(X(I)))
20210 IF NY <>1 THEN R(30)=R(30)+(LOG(Y(I)))
20220 IF NY<>1 THEN R(31)=R(31)+(LOG(Y(I)))*(LOG(Y(I)))
20230 IF NX<>1 AND NY<>1 THEN R(32)=R(32)+(LOG(X(I)))*(LOG(Y(I)))
20240 R(33)=I
20250 R(34)=R(34)+(X(I)/Y(I))
20260 R(35)=R(35)+(Y(I)/X(I))
20270 R(36)=R(36)+((X(I)*X(I)))*Y(I)
20280 R(37)=R(37)+((X(I)*X(I)))/Y(I)
20290 R(38)=R(38)+(Y(I)/(X(I)*X(I)))
20300 R(39)=R(39)+X(I)*(Y(I)*Y(I))
20310 R(40)=R(40)+(X(I)*X(I)*X(I))
20320 R(41)=R(41)+1/((X(I)*X(I)*X(I)))
20330 R(42)=R(42)+(Y(I)*Y(I)*Y(I))
20340 R(43)=R(43)+(X(I)*X(I)*X(I)*X(I))
20350 R(44)=R(44)+1/((X(I)*X(I)*X(I)*X(I)))
20360 IF NX<>1 THEN R(45)=R(45)+LOG(X(I))/X(I)
20370 IF NY<>1 THEN R(46)=R(46)+X(I)*LOG(Y(I))
20380 IF NY<>1 THEN R(47)=R(47)+LOG(Y(I))/X(I)
20390 IF NX<>1 THEN R(48)=R(48)+X(I)*LOG(X(I))
20400 IF NX<>1 THEN R(49)=R(49)+(X(I)*LOG(X(I)))*(X(I)*LOG(X(I)))
20410 IF NX<>1 AND NY<>1 THEN R(50)=R(50)+X(I)*LOG(X(I))*LOG(Y(I))
20420 IF NX<>1 THEN R(51)=R(51)+Y(I)*LOG(X(I))
20430 IF NX<>1 THEN R(52)=R(52)+LOG(X(I))/Y(I)
20440 IF NX<>1 THEN R(53)=R(53)+((LOG(X(I))/X(I)))*((LOG(X(I))/X(I)))
20450 IF NY<>1 THEN R(54)=R(54)+(X(I)*X(I))*LOG(Y(I))
20460 IF NX<>1 THEN R(55)=R(55)+((LOG(X(I))*LOG(X(I))*LOG(X(I))))
20470 IF NX<>1 THEN R(56)=R(56)+((LOG(X(I))*LOG(X(I))*LOG(X(I))*LOG(X(I))))
20480 IF NX<>1 AND NY<>1 THEN R(57)=R(57)+((LOG(X(I))*LOG(X(I))))*LOG(Y(I))
20490 IF NX<>1 AND NY<>1 THEN R(58)=R(58)+(LOG(Y(I))*LOG(X(I)))/X(I)
20500 IF X(I)>=1 THEN Q9=1: GOTO 20540
20501 IF Q9=1 GOTO 20540
20502 IF X(I)<=0 THEN 20550
20505 R(59)=R(59)+LOG(1-X(I))
20510 R(60)=R(60)+(LOG(1-X(I)))*(LOG(1-X(I)))
20520 R(61)=R(61)+LOG(X(I))*LOG(1-X(I))
20530 IF NY<>1 THEN R(62)=R(62)+LOG(Y(I))*LOG(1-X(I))
20540 IF NX<>1 THEN R(63)=R(63)+(LOG(X(I)))/X(I)
20550 NEXT I
20600 NX=0:NY=0
30000 REM * END OF SUMMATION LOOP *
30030 CLS:COLOR 7,1,0: PRINT"SUMS HAVE BEEN CALCULATED--NOW CALCULATING COEFFICIENTS": GOTO 12010
35000 CLS:COLOR 7,1,0:PRINT"EQ #";TAB(9);"COEFFICIENT A";TAB(34);"COEFFICIENT B";TAB(58)"CORRECTED R^2"
35010 FOR I=1 TO 25
35015 PRINT I;TAB(5);A(I);TAB(29);B(I);TAB(54);RC(I)
35016 IF I=22 THEN INPUT"PLEASE PRESS <ENTER> TO CONTINUE";A$
35018 NEXT I
35020 INPUT "Please press <ENTER> to continue ";A$:GOTO 4507
40000 REM * LIST REGISTER CONTENTS R16-R63 *
40010 CLS
40025 CLS:COLOR 7,1,0:PRINT"REGISTER CONTENTS:":PRINT" ":PRINT"REG#";TAB(10);"REGISTER";TAB(34);"REGISTER +1";TAB(57);"REGISTER +2":PRINT" ":FOR I=16 TO 63 STEP 3
40095 PRINT I;TAB(5);R(I);TAB(29);R(I+1);TAB(54);R(I+2)
40100 NEXT I
40105 PRINT" "
40120 INPUT "PLEASE PRESS ENTER TO CONTINUE ";A$
40122 INPUT"OUTPUT TO PRINTER (Y)ES OR (N)O ";A$
40124 IF LEFT$(A$,1)="Y" OR LEFT$(A$,1)="y" THEN 40126 ELSE GOTO 120
40126 FOR I=16 TO 63 STEP 2
40127 LPRINT "R(";I;")= ";R(I);TAB(40);"R(";I+1;")= ";R(I+1)
40128 NEXT I
40129 LPRINT CHR$(12):GOTO 120
50000 IF LEFT$(Q1$,1)="Y" OR LEFT$(Q1$,1)="y" THEN LP=1 ELSE LP=0
50010 RETURN
55000 EQ$(1)="Y=A+B*X":EQ$(2)="Y=B*X":EQ$(3)="Y=1/(A+B*X)":EQ$(4)="Y=A+B*X+C/X":EQ$(5)="Y=A+B/X":EQ$(6)="Y=X/(A*X+B)"
55010 EQ$(7)="Y=A+B/X+C/X*X":EQ$(8)="Y=A+B*X+C*X*X":EQ$(9)="Y=A*X+B*X*X":EQ$(10)="Y=A*X^B":EQ$(11)="Y=A*B^X"
55020 EQ$(12)="Y=B^(1/X)":EQ$(13)="Y=A*X^(B*X)":EQ$(14)="Y=A*X^(B/X)":EQ$(15)="Y=A*e^(B*X)":EQ$(16)="Y=A*e^(B/X)"
55030 EQ$(17)="Y=A+B*lnX":EQ$(18)="Y=1/(A+B*lnX)":EQ$(19)="Y=A*B^X*X^C":EQ$(20)="Y=A*B^(1/X)*X^C"
55040 EQ$(21)="Y=A*e^((X-B)/2)":EQ$(22)="Y=A*e^((lnX-B)^2/C)":EQ$(23)="Y=A*X^B*(1-X)^C":EQ$(24)="Y=A*(X/B)^C*e^(x/b)"
55050 EQ$(25)="Y=1/(A*(X+B)^2+C)":RETURN
61000 IF (ERR=53 OR ERR=64) AND ERL=7050 THEN PRINT "UNABLE TO FIND OR ILLEGAL FILE NAME ";A4$:INPUT "PRESS <ENTER> TO CONTINUE";A$:RESUME 120
63000 IF ERR=64 AND ERL=6050 THEN PRINT" THE FILE NAME ";A4$;" IS NOT A VALID FILE NAME":INPUT"PRESS <ENTER> TO CONTINUE";A$:RESUME 120
63500 IF D1>19 THEN D1=8 ELSE IF D1<8 THEN D1=19
63505 LOCATE D1,7,1,0,31
63510 D1=CSRLIN
63520 A$=INKEY$:IF A$=CHR$(13) THEN 63560
63521 IF A$=CHR$(27) THEN 8000
63523 IF LEN(A$)=2 THEN A$=RIGHT$(A$,1) ELSE GOTO 63500
63525 IF A$="H" THEN D1=D1-1:GOTO 63500
63527 IF A$="P" THEN D1=D1+1:GOTO 63500
63529 GOTO 63500
63530 D1=D1+1:GOTO 63500
63560 D1=CSRLIN
63565 IF CSRLIN=8 THEN 110
63580 IF CSRLIN=9 THEN 7030
63590 IF CSRLIN=10 THEN 2000
63600 IF CSRLIN=11 THEN 3000
63610 IF CSRLIN=12 THEN 9005
63620 IF CSRLIN=13 THEN 4000
63630 IF CSRLIN=14 THEN 4990
63640 IF CSRLIN=15 THEN 10000
63650 IF CSRLIN=16 THEN 4040
63660 IF CSRLIN=17 THEN 40025
63670 IF CSRLIN=18 THEN 6030
63680 IF CSRLIN=19 THEN 8000
63690 GOTO 63500
63700 CLS:COLOR 7,1,0:PRINT"DATA CORRECTION":PRINT" "
63711 CLS:COLOR 7,1,0:M=1:MR=1:MC=1:MR1=1:MC1=1
63712 PRINT "ͻ"
63713 PRINT " CURVEFIT   DATA LIST OF X AND Y VALUES (X$,Y$) NOW IN MEMORY     CURVEFIT "
63714 PRINT "͹"
63715 PRINT " PT # X VALUE  Y VALUE  PT # X VALUE  Y VALUE  PT # X VALUE  Y VALUE "
63716 PRINT "͹"
63717 PRINT "                                                                     "
63718 PRINT "                                                                     "
63719 PRINT "                                                                     "
63720 PRINT "                                                                     "
63721 PRINT "                                                                     "
63722 PRINT "                                                                     "
63723 PRINT "                                                                     "
63724 PRINT "                                                                     "
63725 PRINT "                                                                     "
63726 PRINT "                                                                     "
63727 PRINT "                                                                     "
63728 PRINT "                                                                     "
63729 PRINT "                                                                     "
63730 PRINT "                                                                     "
63731 PRINT "                                                                     "
63732 PRINT "                                                                     "
63733 PRINT "                                                                     "
63734 PRINT "                                                                     "
63735 PRINT "ͼ";
63736 FOR J=1 TO 255
63737 IF X$(J)<>"END" OR Y$(J)<>"END" THEN 63746 ELSE 63800
63746 LOCATE 5+MR,MC+2:PRINT USING "####";M;
63748 LOCATE 5+MR,MC+7:XX1=VAL(X$(M)):PRINT LEFT$(X$(M),8);:LOCATE 5+MR,MC+17:YY1=VAL(Y$(M)):PRINT LEFT$(Y$(M),8);
63749 MR=MR+1
63752 IF M MOD 18=0 THEN MR=1:MC=MC+26
63753 IF M MOD 54=0 THEN MR=1:MC=1:GOTO 63800
63777 M=M+1
63780 NEXT J
63800 LOCATE 25,1:PRINT"PLEASE PRESS <ENTER> FOR MORE DATA ";:INPUT ;A$:IF M<255 AND X$(J)<>"END" THEN 63900 ELSE GOTO 9008
63900 DUMMY$="            ":FOR J9=1 TO 54
63910 LOCATE 5+MR1,MC1+2:PRINT LEFT$(DUMMY$,4);:LOCATE 5+MR1,MC1+7:PRINT LEFT$(DUMMY$,8);:LOCATE 5+MR1,MC1+17:PRINT LEFT$(DUMMY$,8);
63920 MR1=MR1+1:IF J9 MOD 18=0 THEN MR1=1:MC1=MC1+26
63930 IF J9 MOD 54=0 THEN MR1=1:MC1=1
63940 NEXT J9
63950 GOTO 63777
